// SPDX-License-Identifier: GPL-2.0
/*
 * Copyright (C) 2023 Deepcomputing Technology Co., Ltd.
 */
#ifndef __R328_KEY_BUF_H__
#define __R328_KEY_BUF_H__

#include <pthread.h>

typedef struct buf_s {
    char *buf;
    unsigned int nsize;
    unsigned int RIdx;
    unsigned int WIdx;
    unsigned int EndIdx;
    pthread_mutex_t mtx;
}buf_t;

int bufInit(buf_t *pbuf, unsigned int nsize);
int bufGetWriteBufAddr(buf_t *pbuf, char **addr, unsigned int *pnsize);
int bufSkipBuf(buf_t *pbuf, unsigned int nsize);
int bufPushData(buf_t *pbuf, unsigned int nsize);
int bufGetReadBufAddr(buf_t *pbuf, char **addr, unsigned int *pnsize);
int bufSkipData(buf_t *pbuf, unsigned int nsize);
int bufClean(buf_t *pbuf);
int bufDeinit(buf_t *pbuf);
#endif // __R328_KEY_BUF_H__
