// SPDX-License-Identifier: GPL-2.0
/*
 * Copyright (C) 2023 Deepcomputing Technology Co., Ltd.
 */
#ifndef __K1X_KEY_MESSAGE_H__
#define __K1X_KEY_MESSAGE_H__

typedef enum {
	EM_LED_BLUE,
	EM_LED_GREEN
} E_LED;

typedef enum {
	EM_LED_OFF,
	EM_LED_LONG_BRIGHT,       // 
	EM_LED_FBLINK,            // 
	EM_LED_BREATHING,         // 
	EM_LED_RELEASE            // 
} E_LED_MODE;

typedef enum K1X_MESSAGE_TYPE_E
{
    MESSAGE_TYPE_POWEROFF,
    MESSAGE_TYPE_OK,
    MESSAGE_TYPE_FAIL,
    MESSAGE_TYPE_LED_POWER,
    MESSAGE_TYPE_LED_CHARGE,
    MESSAGE_TYPE_UNKNOWN,
    MESSAGE_TYPE_MAX = MESSAGE_TYPE_UNKNOWN,
} K1X_message_type;

typedef struct K1X_meesage_data {
    K1X_message_type type;
    unsigned int value;    
} K1X_meesage_data_t;

int parse_message(char * buf, unsigned int nLen, K1X_meesage_data_t *pdata, unsigned int *pnskip);
int build_message(char * buf, unsigned int nLen, K1X_meesage_data_t *pdata);
#endif // __K1X_KEY_MESSAGE_H__
